/*
 * Colorizer
 * 
 * Version 0.2alpha
 * 
 * 2010-06-11
 * 
 * CopyLeft
 */
package infpp.fractal;

import java.awt.*;

/**
 * The Colorizer interface provides an interface to colorizer objects, which
 * are used to colorize fractals.
 * 
 * @author both
 */
public interface Colorizer {
    /**
     * Calculates a Color given the number of required iterations at a point in
     * a fractal.
     * 
     * @param  numberOfIterations the given number of required iterations
     * @return the calculated Color
     */
    public Color calculateColor(int numberOfIterations);
}
