/*
 * FractalMain
 * 
 * Version 0.2alpha
 * 
 * 2010-06-11
 * 
 * CopyLeft
 */
package infpp.fractal;

/**
 * The FractalMain class contains the static main method.
 * 
 * @author both
 */
public final class FractalMain {
    /**
     * Instantiates a FractalGenerator object and a GUI.
     * 
     * @param args the command line arguments
     */
    public static void main(String[] args) {
	int maxIterations = 256;
        FractalGenerator mandelbrotGenerator
//                = new SimpleDoublePrecisionMandelbrotGenerator(maxIterations);
                = new ThreadedDoublePrecisionMandelbrotGenerator(maxIterations);

        JuliaFractalGenerator juliaGenerator
//                = new SimpleDoublePrecisionJuliaGenerator(maxIterations);
                = new ThreadedDoublePrecisionJuliaGenerator(maxIterations);

        Colorizer mandelbrotColorizer
//                = new DiscreteColorizer(maxIterations);
               = new GrayScaleColorizer(maxIterations);
//                = new FireColorizer(maxIterations);
//        	= new YellowBlueColorizer(maxIterations);

        Colorizer juliaColorizer
//                = new DiscreteColorizer(maxIterations);
                = new GrayScaleColorizer(maxIterations);
//                = new SabrinasColorizer(maxIterations);
//                = new FireColorizer(maxIterations);
//        	= new YellowBlueColorizer(maxIterations);

        new SwingFractalGUI(mandelbrotGenerator, juliaGenerator,
                mandelbrotColorizer, juliaColorizer);
    }
}
