/*
 * JuliaFractalGenerator
 * 
 * Version 0.2alpha
 * 
 * 2010-07-11
 * 
 * CopyLeft
 */
package infpp.fractal;

/**
 * The JuliaFractalGenerator interface provides a means of controlling the
 * operation of a Julia fractal generator.
 * 
 * @author both
 */
public interface JuliaFractalGenerator extends FractalGenerator {
    /**
     * Gets the defining point on the complex plane.
     * 
     * @return the defining point
     */
    public Complex getDefiningPoint();

    /**
     * Sets the defining point on the complex plane to the specified defining
     * point.
     * 
     * @param definingPoint the specified defining point
     */
    public void setDefiningPoint(Complex definingPoint);
}
