/*
 * SabrinasScaleColorizer
 * 
 * Version 0.2alpha
 * 
 * 2010-06-11
 * 
 * CopyLeft
 */
package infpp.fractal;

import java.awt.Color;

/**
 * This colorizer was adapted from a program by Ms. Reif.
 * 
 * @author both
 */
public final class SabrinasColorizer implements Colorizer {
    private final int maxIterations;

    /**
     * Constructs a new SabrinasColorizer.
     * 
     * @param maxIterations the maximum number of iterations of the associated
     *                      fractal generator
     */
    public SabrinasColorizer(int maxIterations) {
        this.maxIterations = maxIterations;
    }

    /**
     * 
     * @param  numberOfIterations the given number of required iterations
     * @return the calculated Color
     * @see    Colorizer#calculateColor(int)
     */
    @Override
    public Color calculateColor(int numberOfIterations) {
	if (numberOfIterations == this.maxIterations) {
	    return Color.BLACK;
	}
        float red = (float) ((numberOfIterations / this.maxIterations) * 250 % 255) / 255;
        float green = (float) ((numberOfIterations * 111) % 97) / 255;
        float blue = (float) ((numberOfIterations * 112) % 250) / 255;
        return new Color(red, green, blue);
    }
}
