/*
 * ThreadedDoublePrecisionMandelbrotGenerator
 * 
 * Version 0.2alpha
 * 
 * 2010-07-15
 * 
 * CopyLeft
 */
package infpp.fractal;

// TODO update the formula in the doc
// In dem Scheme-Programm steht u.a. Folgendes:

//Ersetze die Ursprungsanweisung
//(+  c  (sqr  c-neu))
//in der calcpoint-iter durch die folgende:
//(+  (sqr  c)  (* c  (tan  (sqr  c-neu))))


/**
 * The ThreadedDoublePrecisionMandelbrotGenerator provides an implementation
 * for calculating the number of required iterations to determine the
 * divergence of the sequence of points obtained by the recursion
 * z<sub>1</sub> := 1, z<sub>n + 1</sub> = (z<sub>n</sub>)<sup>2</sup> + c
 * where c is a point determined by screen coordinates.  This implementation
 * operates with standard double precision arithmetic and uses multiple threads
 * to speed up the calculation.
 * 
 * @author both
 */
public class ThreadedDoublePrecisionMistkaeferGenerator
        extends ThreadedDoublePrecisionFractalGenerator {
    private int maxIterations;

    /**
     * Constructs a new ThreadedDoublePrecisionMistkaeferGenerator.
     * 
     * @param maxIterations the maximum number of iterations to use
     */
    public ThreadedDoublePrecisionMistkaeferGenerator(int maxIterations) {
        super();
        this.maxIterations = maxIterations;
    }

    // TODO update the formula in the calculation and the doc
    /**
     * Calculates the number of required iterations to determine the divergence
     * of the sequence of points obtained by the recursion
     * z<sub>1</sub> := 1, z<sub>n + 1</sub> = (z<sub>n</sub>)<sup>2</sup> + c
     * where c is the specified complex number.
     *
     * @param  c the specified complex number
     * @return the number of required iterations
     * @see    FractalGenerator#getNumberOfIterationsAtPixel(int, int)
     */
    @Override
    protected int calculateNumberOfIterationsAtComplex(Complex c) {
        Complex z = new Complex(c);
        int i;
        for (i = 0; i < this.maxIterations && z.getAbsSquare() <= 4; ++i) {
            z.square();
            z.addTo(c);
        }
        return i;
    }
}
